# Coding Problems

* Follow the Problem-Solving Flowchart when solving coding problems:
    1. **Listen/Read carefully** and pay very close attention to any information in the problem description. You probably need *all of it* for an optimal algorithm.
    2. **Debug your example** and make sure your example isn't too small or is a special case. Is there any way it's a special case? Is it big enough?
    3. Get a **brute-force** solution as soon as possible. 
    4. Optimize your brute-force with BUD optimization:
        * **B**ottlenecks
        * **U**nnecessary Work
        * **D**uplicated Work
        Or try some of the following ideas:
        * Look for any **unused info**
        * Solve it manually on an example and then **reverse engineer** your thought process. How did you solve it?
        * Solve it *incorrectly* and then think about why the algorithm fails. Can you fix those issues?
        * Make a **time vs. space tradeoff**.
    5. **Walk through** your optimal solution in *detail*. Make sure you understand each detail before you start coding.
    6. **Implement** and write beautiful code. Modularize your code from the beginning and refactor to clean up anything that's not beautiful.
    7. **Test** your code in the following order:
        1. Test like you would for a code review
        2. Test for unusual or non-standard code
        3. Look for hot spots like arithmetic and null nodes.
        4. Test small test cases
        5. Test for special cases and edge cases